﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;


@Html.DevExpress().GridView(
    Grv =>
    {
        Grv.Name = "GridSPKPI";
        Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridKPIDetail" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.SettingsBehavior.AllowDragDrop = false;

        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;

        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        Grv.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "ChkBoxKPI";
                            chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
                        }
                    ).Render();
            });
        Grv.Columns.Add(
            col =>
            {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));
            });
        Grv.Columns.Add(
            col =>
            {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });
        Grv.Columns.AddBand(x =>
        {
            x.Caption = "Safety";
            x.Columns.Add(
            col =>
            {
                col.Name = "Q1_SAFETY";
                col.Caption = "Q1";
                col.FieldName = "Q1_SAFETY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q2_SAFETY";
                col.Caption = "Q2";
                col.FieldName = "Q2_SAFETY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q3_SAFETY";
                col.Caption = "Q3";
                col.FieldName = "Q3_SAFETY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q4_SAFETY";
                col.Caption = "Q4";
                col.FieldName = "Q4_SAFETY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
                       col =>
                       {
                           col.Name = "TARGET_SAFETY";
                           col.Caption = "Target";
                           col.FieldName = "TARGET_SAFETY";
                           col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           col.Width = Unit.Pixel(80);
                       });
            x.Columns.Add(
                                  col =>
                                  {
                                      col.Name = "ACHIEVEMENT_SAFETY";
                                      col.Caption = "Achieve.";
                                      col.FieldName = "ACHIEVEMENT_SAFETY";
                                      col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                      col.Width = Unit.Pixel(80);
                                  });
        });

        Grv.Columns.AddBand(x =>
        {
            x.Caption = "Quality";
            x.Columns.Add(
            col =>
            {
                col.Name = "Q1_QUALITY";
                col.Caption = "Q1";
                col.FieldName = "Q1_QUALITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q2_QUALITY";
                col.Caption = "Q2";
                col.FieldName = "Q2_QUALITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q3_QUALITY";
                col.Caption = "Q3";
                col.FieldName = "Q3_QUALITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q4_QUALITY";
                col.Caption = "Q4";
                col.FieldName = "Q4_QUALITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
                       col =>
                       {
                           col.Name = "TARGET_QUALITY";
                           col.Caption = "Target";
                           col.FieldName = "TARGET_QUALITY";
                           col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           col.Width = Unit.Pixel(80);
                       });
            x.Columns.Add(
                                  col =>
                                  {
                                      col.Name = "ACHIEVEMENT_QUALITY";
                                      col.Caption = "Achieve.";
                                      col.FieldName = "ACHIEVEMENT_QUALITY";
                                      col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                      col.Width = Unit.Pixel(80);
                                  });
        });
        Grv.Columns.AddBand(x =>
        {
            x.Caption = "Delivery";
            x.Columns.Add(
            col =>
            {
                col.Name = "Q1_DELIVERY";
                col.Caption = "Q1";
                col.FieldName = "Q1_DELIVERY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q2_DELIVERY";
                col.Caption = "Q2";
                col.FieldName = "Q2_DELIVERY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q3_DELIVERY";
                col.Caption = "Q3";
                col.FieldName = "Q3_DELIVERY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q4_DELIVERY";
                col.Caption = "Q4";
                col.FieldName = "Q4_DELIVERY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
                       col =>
                       {
                           col.Name = "TARGET_DELIVERY";
                           col.Caption = "Target";
                           col.FieldName = "TARGET_DELIVERY";
                           col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           col.Width = Unit.Pixel(80);
                       });
            x.Columns.Add(
                                  col =>
                                  {
                                      col.Name = "ACHIEVEMENT_DELIVERY";
                                      col.Caption = "Achieve.";
                                      col.FieldName = "ACHIEVEMENT_DELIVERY";
                                      col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                      col.Width = Unit.Pixel(80);
                                  });
        });
        Grv.Columns.AddBand(x =>
        {
            x.Caption = "Environment";
            x.Columns.Add(
            col =>
            {
                col.Name = "Q1_ENVIRONMENT";
                col.Caption = "Q1";
                col.FieldName = "Q1_ENVIRONMENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q2_ENVIRONMENT";
                col.Caption = "Q2";
                col.FieldName = "Q2_ENVIRONMENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q3_ENVIRONMENT";
                col.Caption = "Q3";
                col.FieldName = "Q3_ENVIRONMENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
            col =>
            {
                col.Name = "Q4_ENVIRONMENT";
                col.Caption = "Q4";
                col.FieldName = "Q4_ENVIRONMENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdKPIMaster = col.PropertiesEdit as ComboBoxProperties;
                cmdKPIMaster.DropDownStyle = DropDownStyle.DropDown;
                List<SysMaster> KPI = Model.GetModel<List<SysMaster>>();
                if (KPI.Count() > 0)
                    KPI.ForEach(s => cmdKPIMaster.Items.Add(s.SYSTEM_CD));
            });
            x.Columns.Add(
                       col =>
                       {
                           col.Name = "TARGET_ENVIRONMENT";
                           col.Caption = "Target";
                           col.FieldName = "TARGET_ENVIRONMENT";
                           col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           col.Width = Unit.Pixel(80);
                       });
            x.Columns.Add(
                                  col =>
                                  {
                                      col.Name = "ACHIEVEMENT_ENVIRONMENT";
                                      col.Caption = "Achieve.";
                                      col.FieldName = "ACHIEVEMENT_ENVIRONMENT";
                                      col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                      col.Width = Unit.Pixel(80);
                                  });
        });
        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedBy";
                col.Caption = "Created By";
                col.FieldName = "CREATED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedDate";
                col.Caption = "Created Date";
                col.FieldName = "CREATED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedBy";
                col.Caption = "ChangedBy";
                col.FieldName = "CHANGED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedDate";
                col.Caption = "Changed Date";
                col.FieldName = "CHANGED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);

                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });


        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;

            //Changed by FID.Reggy
            int StartIndex = 0;
            //int StartIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            int EndIndex = Model.GetModel<List<SPKPI>>() != null ? Model.GetModel<List<SPKPI>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
            //int EndIndex = Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);

            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];

            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;

            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };


        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };

        ///disabled keyfield when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) =>
        {
            MVCxGridView gv = (MVCxGridView)sender;
            string IsEditRow = Request.Params["IsEditRow"];

            if (e.Column.FieldName == "PROD_MONTH")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }


            if (e.Column.FieldName == "Q1_SAFETY")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }

            if (e.Column.FieldName == "Q2_SAFETY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q3_SAFETY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q4_SAFETY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "TARGET_SAFETY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "ACHIEVEMENT_SAFETY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q1_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q2_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q3_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q4_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "TARGET_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "ACHIEVEMENT_QUALITY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q1_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q2_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q3_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q4_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "TARGET_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "ACHIEVEMENT_DELIVERY")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q1_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q2_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q3_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "Q4_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "TARGET_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "ACHIEVEMENT_ENVIRONMENT")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = !gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
        };
    }).Bind(Model.GetModel<List<SPKPI>>()).GetHtml()